unit Unit1;

//Programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IpUtils, IpSock, IpFtp;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    IpFtpClient1: TIpFtpClient;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IpFtpClient1FtpStatus(Sender: TObject;
      StatusCode: TIpFtpStatusCode; const Info: String);
    procedure IpFtpClient1Error(Sender: TObject; Socket: Cardinal;
      ErrCode: Integer; const ErrStr: String);
  private
    { Dclarations prives }
    FLog,FTrans,FError:Boolean;
    procedure WaitLog;
    procedure WaitTransfert;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenDialog1.Execute then Edit4.Text:=OpenDialog1.FileName; //Affiche dans le edit le chemin du fichier
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Screen.Cursor:=crHourGlass; //Curseur sablier
IpFtpClient1.Login(Edit1.Text,Edit2.Text,Edit3.Text,''); //Connexion
WaitLog; //Appel la procedure "WaitLog"
IpFtpClient1.FileType:=ftBinary; //Type de fichier  transfrer (ftAscii pour un fichier texte ou ftBinary pour autres types de fichier)
IpFtpClient1.Store(ExtractFilename(Edit4.Text),Edit4.Text,smReplace,0); //Transfert le fichier
WaitTransfert; //Appel la procedure "WaitTransfert"
IpFtpClient1.LogOut; //Dconnexion
if FError=True then ShowMessage('Une erreur s''est produite.'); //Affiche un message s'il y a eu une erreur
Screen.Cursor:=crDefault; //Curseur par dfaut
end;

procedure TForm1.IpFtpClient1FtpStatus(Sender: TObject;
  StatusCode: TIpFtpStatusCode; const Info: String);
begin
Case StatusCode of
fscLogin : FLog:=True; //La variable "FLog" vaut "True" (indique que l'on est connect au serveur)
fscLogout : FLog:=True; //La variable "FLog" vaut "True" (indique que l'on est dconnect au serveur)
fscTransferOK : FTrans:=True; //La variable "FTrans" vaut "True" (indique le transferet est termin)
end;
end;

procedure TForm1.IpFtpClient1Error(Sender: TObject; Socket: Cardinal;
  ErrCode: Integer; const ErrStr: String);
begin
FError:=True; //La variable "FError" vaut "True" (indique qu'une erreur s'est produite)
end;

procedure TForm1.WaitLog;
begin
FLog:=False; //Initialise la variable "FLog"  False
FError:=False; //Initialise la variable "FError"  False ("FError" permet d'indiquer si il y a une erreur)
repeat //Rpter...
Sleep(100); //Attend 100ms
Application.ProcessMessages; //Interrompt l'excution du programme pour que Windows puisse traiter la file d'attente des messages des autres programmes
until FError or FLog; //...jusqu' ce qu'il y est une erreur ou que la connexion ou la deconnextion est termin
end;

procedure TForm1.WaitTransfert;
begin
FTrans:=False; //Initialise la variable "FTrans"  False ("FTrans" permet d'indiquer lorsque le fichier a t envoy)
FError:=False; //Initialise la variable "FError"  False ("FError" permet d'indiquer si il y a une erreur)
repeat //Rpter...
Sleep(100);
Application.ProcessMessages;
until FError or FTrans; //...jusqu' ce qu'il y est une erreur ou que le transfert est termin
end;

end.
